import propsToAriaRole from "../propsToAriaRole.native.mjs";
describe("modules/AccessibilityUtil/propsToAriaRole", function () {
  test("when missing accessibility props", function () {
    expect(propsToAriaRole({})).toBeUndefined();
  }), test('when "accessibilityRole" is defined', function () {
    expect(propsToAriaRole({
      accessibilityRole: "banner"
    })).toEqual("banner");
  }), test('when "accessibilityRole" is a native-only value', function () {
    expect(propsToAriaRole({
      accessibilityRole: "none"
    })).toEqual("presentation"), expect(propsToAriaRole({
      accessibilityRole: "imagebutton"
    })).toEqual(void 0), expect(propsToAriaRole({
      accessibilityRole: "label"
    })).toEqual(void 0);
  });
});
//# sourceMappingURL=propsToAriaRole-test.native.mjs.map
