import Platform from "../index.native.mjs";
describe("apis/Platform", function () {
  describe("select", function () {
    test('supports "default"', function () {
      expect(Platform.select({
        default: "default"
      })).toEqual("default");
    }), test('chooses "web"', function () {
      expect(Platform.select({
        android: "android",
        ios: "ios",
        web: "web",
        default: "default"
      })).toEqual("web");
    });
  }), describe("isTesting", function () {
    var NODE_ENV_BACKUP = process.env.NODE_ENV;
    afterEach(function () {
      process.env.NODE_ENV = NODE_ENV_BACKUP;
    }), test('true when NODE_ENV is "test"', function () {
      process.env.NODE_ENV = "test", expect(Platform.isTesting).toEqual(!0);
    }), test('false when NODE_ENV is not "test"', function () {
      process.env.NODE_ENV = "development", expect(Platform.isTesting).toEqual(!1);
    });
  });
});
//# sourceMappingURL=index-test.native.mjs.map
