import processColor from "../index.native.mjs";
var platformSpecific = function (x) {
  return x;
};
describe("processColor", function () {
  describe("predefined color names", function () {
    it("should convert red", function () {
      var colorFromString = processColor("red"),
        expectedInt = 4294901760;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    }), it("should convert white", function () {
      var colorFromString = processColor("white"),
        expectedInt = 4294967295;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    }), it("should convert black", function () {
      var colorFromString = processColor("black"),
        expectedInt = 4278190080;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    }), it("should convert transparent", function () {
      var colorFromString = processColor("transparent"),
        expectedInt = 0;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    });
  }), describe("RGB strings", function () {
    it("should convert rgb(x, y, z)", function () {
      var colorFromString = processColor("rgb(10, 20, 30)"),
        expectedInt = 4278850590;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    });
  }), describe("RGBA strings", function () {
    it("should convert rgba(x, y, z, a)", function () {
      var colorFromString = processColor("rgba(10, 20, 30, 0.4)"),
        expectedInt = 1711936542;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    });
  }), describe("HSL strings", function () {
    it("should convert hsl(x, y%, z%)", function () {
      var colorFromString = processColor("hsl(318, 69%, 55%)"),
        expectedInt = 4292558252;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    });
  }), describe("HSLA strings", function () {
    it("should convert hsla(x, y%, z%, a)", function () {
      var colorFromString = processColor("hsla(318, 69%, 55%, 0.25)"),
        expectedInt = 1088109996;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    });
  }), describe("hex strings", function () {
    it("should convert #xxxxxx", function () {
      var colorFromString = processColor("#1e83c9"),
        expectedInt = 4280189897;
      expect(colorFromString).toEqual(platformSpecific(expectedInt));
    });
  });
});
//# sourceMappingURL=index-test.native.mjs.map
